/**************************************************************************/
/*                                                                        */
/*  File: INIT.C                                 Copyright (c) 1998,2000  */
/*  Version: 2.0                                 On Time Informatik GmbH  */
/*                                                                        */
/*                                                                        */
/*                                      On Time        /////////////----- */
/*                                    Informatik GmbH /////////////       */
/* --------------------------------------------------/////////////        */
/*                                  Real-Time and System Software         */
/*                                                                        */
/**************************************************************************/

/* Some standard initializations for RTFiles-32 programs.

   This file is linked with most RTFiles-32 demo programs. It provides a
   convinient place to configure RTTarget-32 and RTFiles-32.

*/

#include <rttarget.h>
#include <rtfiles.h>

// If you want to redefine the size of some RTFiles-32 internal tables,
// uncomment #include <rtfdata.c> and any of the preceedig constants
// below. The values given below correspond to RTFiles-32's default:

//#define RTF_MAX_DRIVES 8      // max logical drives, can be set up to 32
//#define RTF_MAX_FILES  8      // max open file, can be set to any value >= 2
//#define RTF_MAX_BUFFERS 32    // number of sector buffers of the buffer cache
//
//#include <rtfdata.c>


// The following declaration corresponds to RTFiles-32's default device list
// which supports up to two floppies and up to two IDE disks on the primary
// IDE channel.

// static RTFDrvFLPYData FLPYDriveAData = {0};
// static RTFDrvFLPYData FLPYDriveBData = {0};
// static RTFDrvIDEData  IDEDriveCData  = {0};
// static RTFDrvIDEData  IDEDriveDData  = {0};
// 
// RTFDevice RTFDeviceList[] =
// { { RTF_DEVICE_FLOPPY, 0, 0, &RTFDrvFloppy, &FLPYDriveAData },
//   { RTF_DEVICE_FLOPPY, 1, 0, &RTFDrvFloppy, &FLPYDriveBData },
//   { RTF_DEVICE_FDISK , 0, 0, &RTFDrvIDE,    &IDEDriveCData },
//   { RTF_DEVICE_FDISK , 1, 0, &RTFDrvIDE,    &IDEDriveDData },
//   { 0 }
// };

// The following example would be used if you use a single DiskOnChip and
// no IDE or floppy disks:
//
// static RTFDrvDOCData Disk0Data = {0};
// RTFDevice RTFDeviceList[] =
// { { RTF_DEVICE_FDISK , 0, 0, &RTFDrvDOC, &Disk0Data },
//   { 0 }
// };
//
// This example would also require an entry in your
// RTTarget-32 configuration file such as:
//   Region DiskOnChip D0000h 8k Device ReadWrite

// The exported init function below is executed before the run-time system
// startup code.

#ifdef _MSC_VER
__declspec(dllexport) void          Init(void)
#else
                      void __export Init(void)
#endif
{
   RTSetFlags(RT_MM_VIRTUAL | RT_CLOSE_FIND_HANDLES, 1);
   RTCMOSExtendHeap();            // get as much memory as we can
   RTCMOSSetSystemTime();         // get the right date and time
// RTEmuInit();                   // only if you need it
}
