
#if _LINUX
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#else
/* win32 and rtos-32 */
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#endif

#include "heapi.h"

HE_HANDLE 		hDevice;
HE_DWORD 		Status;

int main(int argc, char *argv[])
{
	HE_WORD		 Board;
	HE_DWORD	 switches[4];
	char		*devname;
	int			 errorcode;
	char		 text[120];

	if (argc != 3)
	{
		printf("Usage example Device BoardNo\n");
		printf("eg testint hep8a 0\n\n");
#if _RTOS32
		printf("Press a key to continue...\n");
		getch();
#endif
		return 1;
	}

#if _RTOS32
	// Initialize the kernel and keyboard driver
	RTKernelInit(5);
	KBInit();
#endif

	devname		= argv[1];
	Board		= (HE_WORD)atoi(argv[2]);
	hDevice 	= NULL;
	switches[0]	= HE_Switch_TestInterrupt;
	switches[1]	= HE_Switch_Last;

	Status = HeOpenS(devname, Board, "fifoa", &hDevice, switches);
	switch (Status)
	{
	case HE_OK: 
		printf("Interrupts work fine.\n");
		HeClose(&hDevice);
		break;

	case HE_PingIntFailed:
		printf("Interrupt test failed.\n");
		HeClose(&hDevice);
		break;

	case HE_InterruptsDisabled:
		printf("Interrupts disabled.\n");
		HeClose(&hDevice);
		break;

	default:
		printf("Interrupt test failed, due to a driver problem.\n");
		HeErr2Text(Status, text);
		errorcode=HeGetLastOsError(hDevice);
		printf("Status - %s, OsError = %d\n", text, errorcode);
		break;
	}

#if _RTOS32
	// After this getch, RTOS32 will reboot (default behaviour of
	// RTOS32 after a program ends or exits).
	getch();
#endif

	return 1;
}
