

#define _VXWORKS	1


#ifdef _VXWORKS
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "vxWorks.h"

/*
#include "aio.h"
#include "aioSysDrv.h"
*/

#include "errno.h"
#include "taskLib.h"
#include "heapi\heapi.h"
#include "heapi\hecodes.h"
#include "ctype.h"
#include "ioLib.h"
#include "iosLib.h"
#include "usrLib.h"

#else
#include <windows.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>
#include <dos.h>
#include <string.h>
#include <signal.h>

#include "header.h"
#include "heapi.h"

#endif

HE_HANDLE	hDevice;
HE_DWORD	Status;

void error(HE_DWORD errorcode)
{
	char text[120];
	printf("In error routine\n");
	HeErr2Text(Status, text);
	printf("Failed - %s, OsError = %ld\n", text, errorcode);

	Status = HeClose(&hDevice);
	exit(1);
}

extern HE_DWORD HeBaseInt(HE_HANDLE hDevice, HE_DWORD *iobase, HE_DWORD *irq);

void ShowIoBaseIRQ(char *devname, int Board, HE_DWORD *switches)
{
	HE_DWORD Status, iobase, irq;

	hDevice = NULL;

	switches[0]=HE_Switch_NoInterrupts;	
	switches[0]=HE_Switch_NoPCIMasterMode;
	switches[0]=HE_Switch_IRQ12;
	switches[1]=HE_Switch_Last;

	Status = HeOpenS(devname, Board, "ComportA", &hDevice, switches);
	if (Status != HE_OK) error(HeGetLastOsError(hDevice));

	printf("\nBoard %s is mapped to memory address and IRQ:-\n", devname);
        Status = HeBaseInt(hDevice, &iobase, &irq);
        if (Status == HE_OK)
        {
           printf("IoBase %lx\n", iobase);
           printf("IRQ    %lx\n", irq);
        }
        else
        {
           printf("Error in getting IoBase and IRQ (%lx)\n", Status);
        }

	Status = HeClose(&hDevice);
	if(Status != HE_OK) error(HeGetLastOsError(hDevice));
}

void PingInt(char *devname, int Board, HE_DWORD *switches)
{
	hDevice = NULL;

	switches[0]=HE_Switch_TestInterrupt;
	switches[1]=HE_Switch_IRQ12;
	switches[2]=HE_Switch_Last;

	Status = HeOpenS(devname, Board, "ComportA", &hDevice, switches);

	printf("\nInterrupt test:-\n");
	switch (Status)
	{
		case HE_PingIntFailed		: printf("Interrupts failed\n");		break;
		case HE_OK			: printf("Interrupts OK\n");			break;
		case HE_InterruptsDisabled	: printf("Interrupts disabled\n");		break;
		default				: printf("Interrupts failed, unknown error\n");	break;
	}

	Status = HeClose(&hDevice);
	if(Status != HE_OK) error(HeGetLastOsError(hDevice));
}


void TestInt(char devname[5], int Board, char comm[1])
{
	HE_BOOLEAN		UseComportA;
	char			Comport[20];
	HE_DWORD		switches[16];
  
	hDevice			= NULL;

	strcpy(Comport, "comport");			/* First Part of the string is Comport*/
	strcat(Comport, comm);				/* append user supplied code - A or B, ...*/
 	UseComportA	= (tolower(comm[0]) == 'a');

	if ((strcmp(devname, "hep8a")==0)||
	    (strcmp(devname, "HEP8A")==0)  )
	{
		PingInt      (devname, Board, switches);
		ShowIoBaseIRQ(devname, Board, switches);
	}
	else
	{
		printf("Sorry, this test is only supported for HERON based systems.\n");
	}
}

